//
//  Filename:	QFoldout.h
//	Created:	17:3:2008   19:27

#ifndef		__QFoldout_H__
#define		__QFoldout_H__

/*
=========================================================================================

			HEADERS & DEFS

=========================================================================================
*/

#include	<QtGui/QtGui>
#include	<map>
#include	<vector>

/*
=========================================================================================

			CODE

=========================================================================================
*/

class QFoldout : public QWidget {

	Q_OBJECT;

	typedef std::map< std::string, QPushButton* >	tButtonMap;
	typedef tButtonMap::const_iterator				tButtonMapIter;
	typedef std::map< std::string, QGroupBox* >		tGroupBoxMap;
	typedef tGroupBoxMap::const_iterator			tGroupBoxMapIter;
	typedef std::vector< QPushButton* >				tCategoryButtons;
	typedef std::vector< QGroupBox* >				tCategoryGroups;

private:

	tButtonMap			buttonMap;
	tGroupBoxMap		groupBoxMap;
	tCategoryButtons	categoryButtons;
	tCategoryGroups		categoryGroups;
	QScrollArea			*scroll;

private slots:

	void				OnCategoryButtonClicked( bool checked );

private:

	void				Layout( void );
	QPushButton*		GetPageButton( const std::string& pageName ) const;
	QGroupBox*			GetPageGroup( const std::string& pageName ) const;

public:

						QFoldout( QWidget *parent );

	void				AddPage( const std::string& name, const std::string& caption, QGroupBox *group );
	void				RemovePage( const std::string& name );

	void				SetPageVisible( const std::string& name, bool visible );
	void				SetPageOpened( const std::string& name, bool opened );
	void				SetPageCaption( const std::string& name, const std::string& caption );

	bool				IsPageVisible( const std::string& name ) const;

	virtual QSize		sizeHint( void ) const { return size(); }
	virtual void		showEvent( QShowEvent *event ) { Layout(); }
};

#endif		/*	!__QFoldout_H__	*/